"""
Script obtenu sur mathweb.fr
Uniquement pour les aboné·e·s
Auteur: Stéphane Pasquet
"""

from tkinter import Label, Text, Tk, PhotoImage, LEFT, Toplevel, filedialog, Button, END, StringVar, Entry
import tkinter.ttk as ttk
from speech_recognition import Recognizer, Microphone
from webbrowser import open_new

"""
Infobulles
"""

class infoBulle(Toplevel):
    def __init__(self,parent=None,texte='',temps=500):
        Toplevel.__init__(self , parent , bd = 1 , bg = 'black')
        self.tps = temps
        self.parent = parent
        self.withdraw()
        self.overrideredirect(1)
        self.transient()     
        l = Label(self,text=texte,bg="yellow",justify='left')
        l.update_idletasks()
        l.pack()
        l.update_idletasks()
        self.tipwidth = l.winfo_width()
        self.tipheight = l.winfo_height()
        self.parent.bind('<Enter>',self.delai)
        self.parent.bind('<Button-1>',self.efface)
        self.parent.bind('<Leave>',self.efface)
        
    def delai(self,event):
        self.action=self.parent.after(self.tps,self.affiche)
        
    def affiche(self):
        self.update_idletasks()
        posX = self.parent.winfo_rootx()+self.parent.winfo_width()
        posY = self.parent.winfo_rooty()+self.parent.winfo_height()
        if posX + self.tipwidth > self.winfo_screenwidth():
            posX = posX-self.winfo_width()-self.tipwidth
        if posY + self.tipheight > self.winfo_screenheight():
            posY = posY-self.winfo_height()-self.tipheight
        self.geometry('+%d+%d'%(posX,posY))
        self.deiconify()
    def efface(self,event):
        self.withdraw()
        self.parent.after_cancel(self.action)

"""
Paramètres
"""

class Parametres:
    def __init__(self):
        self.window = Tk()
        self.window.geometry('700x100')
        self.window.title('Paramètres')
        self.window.iconbitmap("micro.ico")
        self.window.resizable(0,0)
        Fichier = open('lang.txt' , 'r', encoding = 'utf8')
        self.lang = Fichier.read()
        Fichier.close()
        
                
        Label(self.window, text = "Language :").place(x = 5 , y = 5)
        self.newlang = StringVar()
        self.e = Entry(self.window, width = 10, bg = 'white', textvariable = self.newlang)
        self.e.place(x = 90 , y = 5)
        self.e.insert(0,self.lang)
        Label(self.window, text = "Vous pouvez changer cette valeur conformément aux langues acceptées. Voir la page:").place(x = 90 , y = 25)
        link = Label(self.window, text = "https://cloud.google.com/speech-to-text/docs/languages", fg="blue", cursor="hand2")
        link.place(x = 90 , y = 45)
        link.bind("<Button-1>", lambda e: open_new("https://cloud.google.com/speech-to-text/docs/languages"))
        self.e.bind('<Return>',self.record_lang)
        Label(self.window, text = "Validez en appuyant sur [ENTER].").place(x = 90 , y = 65)
        
    def record_lang(self,event):
        Fichier = open('lang.txt' , 'w', encoding = 'utf8')
        Fichier.write( self.e.get() )
        Fichier.close()
        self.window.destroy()



"""
Reconnaissance vocale
"""

class VocalSearch:
    def __init__(self, window):
        self.window = window
        self.window.geometry('145x135')
        #self.window.title('Clic & Speak')
        self.window.iconbitmap("micro.ico")
        self.window.resizable(0,0)
        with open('lang.txt') as f:
            for line in f:
                self.lang = line
        self.main()
        
    def main(self):
        self.back = PhotoImage(file = 'micro.png')
        self.background = self.back.subsample(1, '1')
        self.info = ttk.Button(self.window, image=self.background , compound = LEFT, width=1 , command=self.search)
        self.info.image = self.background
        self.info.place(x=0,y=0)
        infoBulle(parent = self.info , texte="Click here & speak")
        #
        self.backParam = PhotoImage(file = 'param.png')
        self.backgroundParam = self.backParam.subsample(1, '1')
        self.infoParam = ttk.Button(self.window, image=self.backgroundParam , compound = LEFT, width=1 , command=self.parametres)
        self.infoParam.image = self.backgroundParam
        self.infoParam.place(x=0,y=0)
        infoBulle(parent = self.infoParam , texte="Paramètres")
    
    def search(self):
        self.back = PhotoImage(file = 'speak.png')
        self.background = self.back.subsample(1, '1')
        self.info = ttk.Button(self.window, image=self.background , compound = LEFT, width=1)
        self.info.image = self.background
        self.info.place(x=0,y=0)
        infoBulle(parent = self.info , texte="wait 1 second and speak")
        self.recognizer = Recognizer()
        with Microphone() as source:
            self.audio = self.recognizer.listen(source)
        try:
            self.text = self.recognizer.recognize_google(self.audio , language = self.lang)
            self.link = "https://www.google.com/search?q="+self.text.replace(' ','+')
            open_new(self.link)
            self.main()
        except Exception as ex:
            self.not_recognize()
            
    def not_recognize(self):
        self.back = PhotoImage(file = 'interrogation.png')
        self.background = self.back.subsample(1, '1')
        self.info = ttk.Button(self.window, image=self.background , compound = LEFT, width=1 , command=self.search)
        self.info.image = self.background
        self.info.place(x=0,y=0)
        infoBulle(parent = self.info , texte="I don't understand...")
        self.window.after(2000,self.search)
        
      
    def parametres(self):
        appParam = Parametres()
    
            
        
root = Tk()
app = VocalSearch(root)
root.mainloop()
